PROGRAM GAME1;
(*--------------------------------------------------------------------------*)
(* Lsning til GAME, der beregner en vindende (ikke optimal) strategi.      *)
(*--------------------------------------------------------------------------*)

USES PLAY;

CONST                               (*------------------------------------*)
  ML = 100;                         (* Maksimale antal tal p pladen      *)
VAR                                 (*------------------------------------*)
  Move      : CHAR;                 (* 'L'/'R' - angiver side, der vlges *)
  Board     : Array[1..ML] OF BYTE; (* Spilleplade, med op til ML tal     *)
  Index     ,                       (* hjlpevariabel                     *)
  Left      ,                       (* Aktuelle venstrekant               *)
  Right     : BYTE;                 (* Aktuelle hjrekant                 *)
  LeftScore ,                       (* Summen af tal p ulige pladser     *)
  RightScore,                       (* Summen af tal p lige pladser      *)
  MyScore   ,                       (* Summen af mine tal                 *)
  YourScore : WORD;                 (* Summen af modstanderens tal        *)
  InFile    ,                       (* Input fil                          *)
  OutFile   : TEXT;                 (* Output fil                         *)
                                    (*------------------------------------*)

PROCEDURE Init;
BEGIN

   (* Read input *)
      ASSIGN(InFile,Inname); RESET(InFile);
      ReadLn(InFile,Right);
      FOR Left:=1 TO Right DO ReadLn(InFile,Board[Left]);
      CLOSE(InFile);

   (* Initialise variables *)
      LeftScore:=0; RightScore:=0; Index:=1;
      REPEAT
         INC(LeftScore,Board[Index]);  Inc(Index);
         INC(RightScore,Board[Index]); Inc(Index);
      UNTIL Index>=Right;

      MyScore:=0; YourScore:=0; Left:=1;

END;

PROCEDURE Update(VAR Score: WORD; Pick: CHAR);
BEGIN
   IF Pick='L' THEN BEGIN
      INC(Score,Board[Left]);
      INC(Left);
   END ELSE BEGIN
      INC(Score,Board[Right]);
      DEC(Right);
   END;
END;

PROCEDURE WriteResult;
BEGIN
   ASSIGN(OutFile,'OUTPUT.TXT'); REWRITE(OutFile);
   WriteLn(OutFile,MyScore,' ',YourScore);
   CLOSE(OutFile);
END;

BEGIN
   Init;
   StartGame;

   IF LeftScore>=RightScore THEN Move:='L' ELSE Move:='R';
   REPEAT
      MyMove(Move);
      Update(MyScore,Move);

      YourMove(Move);
      Update(YourScore,Move);
   UNTIL Left>=Right;

   WriteResult;
END.

